Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 3633)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 3634)
@@ -3706,128 +4007,119 @@
 
                 tend(k,j,i) = tend(k,j,i) - (                                 &
-                        ( flux_r(k) + diss_r(k) - swap_flux_x_local(k,j) -    &
-                          swap_diss_x_local(k,j)            ) * ddx           &
-                      + ( flux_n(k) + diss_n(k) - swap_flux_y_local(k)   -    &
-                          swap_diss_y_local(k)              ) * ddy           &
-                      + ( ( flux_t(k) + diss_t(k) ) -                         &
-                          ( flux_d    + diss_d    )                           &
-                                                    ) * drho_air(k) * ddzw(k) &
+                        ( ( flux_r + diss_r )                                 &
+                      -   ( flux_l + diss_l ) ) * ddx                         &
+                      + ( ( flux_n + diss_n )                                 &
+                      -   ( flux_s + diss_s ) ) * ddy                         &
+                      + ( ( flux_t + diss_t )                                 &
+                      -   ( flux_d + diss_d ) ) * drho_air(k) * ddzw(k)       &
                                             ) + sk(k,j,i) * div
 
-                swap_flux_y_local(k)   = flux_n(k)
-                swap_diss_y_local(k)   = diss_n(k)
-                swap_flux_x_local(k,j) = flux_r(k)
-                swap_diss_x_local(k,j) = diss_r(k)
-                flux_d                 = flux_t(k)
-                diss_d                 = diss_t(k)
-
-             ENDDO
-!
-!--          Evaluation of statistics. 
-             SELECT CASE ( sk_char )
-
-                 CASE ( 'pt' )
-                    DO  k = nzb, nzt
+#ifndef _OPENACC
+                swap_flux_y_local(k)   = flux_n
+                swap_diss_y_local(k)   = diss_n
+                swap_flux_x_local(k,j) = flux_r
+                swap_diss_x_local(k,j) = diss_r
+#endif
+                flux_d                 = flux_t
+                diss_d                 = diss_t
+
+!
+!--             Evaluation of statistics. 
+                SELECT CASE ( sk_num )
+
+                    CASE ( 1 )
+                       !$ACC ATOMIC
                        sums_wspts_ws_l(k,tn) = sums_wspts_ws_l(k,tn)           &
-                          + ( flux_t(k)                                        &
+                          + ( flux_t                                           &
                                 / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
                                 * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t(k)                                        &
+                            + diss_t                                           &
                                 / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
                                 *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
                             ) * weight_substep(intermediate_timestep_count)
-                    ENDDO
-                 CASE ( 'sa' )
-                    DO  k = nzb, nzt
+                    CASE ( 2 )
+                       !$ACC ATOMIC
                        sums_wssas_ws_l(k,tn) = sums_wssas_ws_l(k,tn)           &
-                          + ( flux_t(k)                                        &
+                          + ( flux_t                                           &
                                 / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
                                 * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t(k)                                        &
+                            + diss_t                                           &
                                 / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
                                 *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
                             ) * weight_substep(intermediate_timestep_count)
-                    ENDDO
-                 CASE ( 'q' )
-                    DO  k = nzb, nzt
+                    CASE ( 3 )
+                       !$ACC ATOMIC
                        sums_wsqs_ws_l(k,tn)  = sums_wsqs_ws_l(k,tn)            &
-                          + ( flux_t(k)                                        &
+                          + ( flux_t                                           &
                                 / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
                                 * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t(k)                                        &
+                            + diss_t                                           &
                                 / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
                                 *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
                             ) * weight_substep(intermediate_timestep_count)
-                    ENDDO
-                 CASE ( 'qc' )
-                    DO  k = nzb, nzt
+                    CASE ( 4 )
+                       !$ACC ATOMIC
                        sums_wsqcs_ws_l(k,tn)  = sums_wsqcs_ws_l(k,tn)          &
-                          + ( flux_t(k)                                        &
+                          + ( flux_t                                           &
                                 / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
                                 * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t(k)                                        &
+                            + diss_t                                           &
                                 / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
                                 *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
                             ) * weight_substep(intermediate_timestep_count)
-                    ENDDO
-                 CASE ( 'qr' )
-                    DO  k = nzb, nzt
+                    CASE ( 5 )
+                       !$ACC ATOMIC
                        sums_wsqrs_ws_l(k,tn)  = sums_wsqrs_ws_l(k,tn)          &
-                          + ( flux_t(k)                                        &
+                          + ( flux_t                                           &
                                 / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
                                 * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t(k)                                        &
+                            + diss_t                                           &
                                 / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
                                 *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
                             ) * weight_substep(intermediate_timestep_count)
-                    ENDDO
-                 CASE ( 'nc' )
-                    DO  k = nzb, nzt
+                    CASE ( 6 )
+                       !$ACC ATOMIC
                        sums_wsncs_ws_l(k,tn)  = sums_wsncs_ws_l(k,tn)          &
-                          + ( flux_t(k)                                        &
+                          + ( flux_t                                           &
                                 / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
                                 * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t(k)                                        &
+                            + diss_t                                           &
                                 / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
                                 *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
                             ) * weight_substep(intermediate_timestep_count)
-                    ENDDO
-                 CASE ( 'nr' )
-                    DO  k = nzb, nzt
+                    CASE ( 7 )
+                       !$ACC ATOMIC
                        sums_wsnrs_ws_l(k,tn)  = sums_wsnrs_ws_l(k,tn)          &
-                          + ( flux_t(k)                                        &
+                          + ( flux_t                                           &
                                 / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
                                 * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t(k)                                        &
+                            + diss_t                                           &
                                 / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
                                 *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
                             ) * weight_substep(intermediate_timestep_count)
-                    ENDDO
-                 CASE ( 's' )
-                    DO  k = nzb, nzt
+                    CASE ( 8 )
+                       !$ACC ATOMIC
                        sums_wsss_ws_l(k,tn)  = sums_wsss_ws_l(k,tn)            &
-                          + ( flux_t(k)                                        &
+                          + ( flux_t                                           &
                                 / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
                                 * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t(k)                                        &
+                            + diss_t                                           &
                                 / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
                                 *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
                             ) * weight_substep(intermediate_timestep_count)
-                    ENDDO  
-     
-                 CASE ( 'aerosol_mass', 'aerosol_number', 'salsa_gas' )
-                     DO  k = nzb, nzt
+                    CASE ( 9 )
+                        !$ACC ATOMIC
                         sums_salsa_ws_l(k,tn)  = sums_salsa_ws_l(k,tn)         &
-                          + ( flux_t(k)                                        &
+                          + ( flux_t                                           &
                                 / ( w(k,j,i) + SIGN( 1.0E-20_wp, w(k,j,i) ) )  &
                                 * ( w(k,j,i) - hom(k,1,3,0)                 )  &
-                            + diss_t(k)                                        &
+                            + diss_t                                           &
                                 / ( ABS(w(k,j,i)) + 1.0E-20_wp              )  &
                                 *   ABS(w(k,j,i) - hom(k,1,3,0)             )  &
                             ) * weight_substep(intermediate_timestep_count)
-                     ENDDO                    
-                                   
-
-              END SELECT
+
+                END SELECT
+
+             ENDDO
 
          ENDDO
@@ -3874,7 +4166,17 @@
        REAL(wp)    ::  ibit10 !< flag indicating 3rd-order scheme along x-direction
        REAL(wp)    ::  ibit11 !< flag indicating 5th-order scheme along x-direction
+#ifdef _OPENACC
+       REAL(wp)    ::  ibit9_l  !< flag indicating 1st-order scheme along x-direction
+       REAL(wp)    ::  ibit10_l !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp)    ::  ibit11_l !< flag indicating 5th-order scheme along x-direction
+#endif
        REAL(wp)    ::  ibit12 !< flag indicating 1st-order scheme along y-direction
        REAL(wp)    ::  ibit13 !< flag indicating 3rd-order scheme along y-direction
        REAL(wp)    ::  ibit14 !< flag indicating 5th-order scheme along y-direction
+#ifdef _OPENACC
+       REAL(wp)    ::  ibit12_s !< flag indicating 1st-order scheme along y-direction
+       REAL(wp)    ::  ibit13_s !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)    ::  ibit14_s !< flag indicating 5th-order scheme along y-direction
+#endif
        REAL(wp)    ::  ibit15 !< flag indicating 1st-order scheme along z-direction
        REAL(wp)    ::  ibit16 !< flag indicating 3rd-order scheme along z-direction
@@ -3886,23 +4188,38 @@
        REAL(wp)    ::  gv     !< Galilei-transformation velocity along y 
        REAL(wp)    ::  v_comp !< advection velocity along y
+#ifdef _OPENACC
+       REAL(wp)    ::  v_comp_s !< advection velocity along y
+#endif
        REAL(wp)    ::  w_comp !< advection velocity along z
        
+       REAL(wp)    :: diss_s  !< discretized artificial dissipation at southward-side of the grid box
+       REAL(wp)    :: flux_s  !< discretized 6th-order flux at southward-side of the grid box
+#ifndef _OPENACC
        REAL(wp), DIMENSION(nzb+1:nzt) ::  swap_diss_y_local_u !< discretized artificial dissipation at southward-side of the grid box
        REAL(wp), DIMENSION(nzb+1:nzt) ::  swap_flux_y_local_u !< discretized 6th-order flux at southward-side of the grid box
+#endif
        
+       REAL(wp)    :: diss_l  !< discretized artificial dissipation at leftward-side of the grid box
+       REAL(wp)    :: flux_l  !< discretized 6th-order flux at leftward-side of the grid box
+#ifndef _OPENACC
        REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_diss_x_local_u !< discretized artificial dissipation at leftward-side of the grid box
        REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_flux_x_local_u !< discretized 6th-order flux at leftward-side of the grid box
+#endif
        
-       REAL(wp), DIMENSION(nzb:nzt) ::  diss_n !< discretized artificial dissipation at northward-side of the grid box
-       REAL(wp), DIMENSION(nzb:nzt) ::  diss_r !< discretized artificial dissipation at leftward-side of the grid box
-       REAL(wp), DIMENSION(nzb:nzt) ::  diss_t !< discretized artificial dissipation at top of the grid box
-       REAL(wp), DIMENSION(nzb:nzt) ::  flux_n !< discretized 6th-order flux at northward-side of the grid box
-       REAL(wp), DIMENSION(nzb:nzt) ::  flux_r !< discretized 6th-order flux at rightward-side of the grid box
-       REAL(wp), DIMENSION(nzb:nzt) ::  flux_t !< discretized 6th-order flux at top of the grid box
-       REAL(wp), DIMENSION(nzb:nzt) ::  u_comp !< advection velocity along x
+       REAL(wp) ::  diss_n !< discretized artificial dissipation at northward-side of the grid box
+       REAL(wp) ::  diss_r !< discretized artificial dissipation at leftward-side of the grid box
+       REAL(wp) ::  diss_t !< discretized artificial dissipation at top of the grid box
+       REAL(wp) ::  flux_n !< discretized 6th-order flux at northward-side of the grid box
+       REAL(wp) ::  flux_r !< discretized 6th-order flux at rightward-side of the grid box
+       REAL(wp) ::  flux_t !< discretized 6th-order flux at top of the grid box
+       REAL(wp) ::  u_comp !< advection velocity along x
+#ifdef _OPENACC
+       REAL(wp)    ::  u_comp_l !<
+#endif
  
        gu = 2.0_wp * u_gtrans
        gv = 2.0_wp * v_gtrans
 
+#ifndef _OPENACC
 !
 !--    Compute the fluxes for the whole left boundary of the processor domain.
@@ -3915,6 +4232,6 @@
              ibit9  = REAL( IBITS(advc_flags_1(k,j,i-1),9,1),  KIND = wp )
 
-             u_comp(k)                = u(k,j,i) + u(k,j,i-1) - gu
-             swap_flux_x_local_u(k,j) = u_comp(k) * (                          &
+             u_comp                   = u(k,j,i) + u(k,j,i-1) - gu
+             swap_flux_x_local_u(k,j) = u_comp * (                             &
                                        ( 37.0_wp * ibit11 * adv_mom_5          &
                                     +     7.0_wp * ibit10 * adv_mom_3          &
@@ -3931,5 +4248,5 @@
                                                    )
 
-              swap_diss_x_local_u(k,j) = - ABS( u_comp(k) ) * (                &
+              swap_diss_x_local_u(k,j) = - ABS( u_comp ) * (                   &
                                        ( 10.0_wp * ibit11 * adv_mom_5          &
                                     +     3.0_wp * ibit10 * adv_mom_3          &
@@ -3950,10 +4267,10 @@
           DO  k = nzb_max+1, nzt
 
-             u_comp(k)         = u(k,j,i) + u(k,j,i-1) - gu
-             swap_flux_x_local_u(k,j) = u_comp(k) * (                          &
+             u_comp            = u(k,j,i) + u(k,j,i-1) - gu
+             swap_flux_x_local_u(k,j) = u_comp * (                             &
                              37.0_wp * ( u(k,j,i) + u(k,j,i-1)   )             &
                            -  8.0_wp * ( u(k,j,i+1) + u(k,j,i-2) )             &
                            +           ( u(k,j,i+2) + u(k,j,i-3) ) ) * adv_mom_5
-             swap_diss_x_local_u(k,j) = - ABS(u_comp(k)) * (                   &
+             swap_diss_x_local_u(k,j) = - ABS(u_comp) * (                      &
                              10.0_wp * ( u(k,j,i) - u(k,j,i-1)   )             &
                            -  5.0_wp * ( u(k,j,i+1) - u(k,j,i-2) )             &
@@ -3962,6 +4279,25 @@
           ENDDO
        ENDDO
-
+#endif
+
+       !$ACC PARALLEL LOOP COLLAPSE(2) FIRSTPRIVATE(tn, gu, gv) &
+       !$ACC PRIVATE(i, j, k, k_mm, k_pp, k_ppp) &
+       !$ACC PRIVATE(ibit9, ibit10, ibit11, ibit12, ibit13, ibit14) &
+       !$ACC PRIVATE(ibit9_l, ibit10_l, ibit11_l) &
+       !$ACC PRIVATE(ibit12_s, ibit13_s, ibit14_s) &
+       !$ACC PRIVATE(ibit15, ibit16, ibit17) &
+       !$ACC PRIVATE(flux_r, diss_r, flux_l, diss_l) &
+       !$ACC PRIVATE(flux_n, diss_n, flux_s, diss_s) &
+       !$ACC PRIVATE(flux_t, diss_t, flux_d, diss_d) &
+       !$ACC PRIVATE(div, u_comp, u_comp_l, v_comp, v_comp_s, w_comp) &
+       !$ACC PRESENT(advc_flags_1) &
+       !$ACC PRESENT(u, v, w) &
+       !$ACC PRESENT(drho_air, rho_air_zw, ddzw) &
+       !$ACC PRESENT(tend) &
+       !$ACC PRESENT(hom(nzb+1:nzb_max,1,1:3,0)) &
+       !$ACC PRESENT(weight_substep(intermediate_timestep_count)) &
+       !$ACC PRESENT(sums_us2_ws_l, sums_wsus_ws_l)
        DO i = nxlu, nxr
+#ifndef _OPENACC
 !       
 !--       The following loop computes the fluxes for the south boundary points
@@ -4019,10 +4355,10 @@
 
           ENDDO
+#endif
+
 !
 !--       Computation of interior fluxes and tendency terms
           DO  j = nys, nyn
 
-             flux_t(0) = 0.0_wp
-             diss_t(0) = 0.0_wp
              flux_d    = 0.0_wp
              diss_d    = 0.0_wp
@@ -4034,6 +4370,6 @@
                 ibit9  = REAL( IBITS(advc_flags_1(k,j,i),9,1),  KIND = wp )
 
-                u_comp(k) = u(k,j,i+1) + u(k,j,i)
-                flux_r(k) = ( u_comp(k) - gu ) * (                           &
+                u_comp = u(k,j,i+1) + u(k,j,i)
+                flux_r = ( u_comp - gu ) * (                                 &
                           ( 37.0_wp * ibit11 * adv_mom_5                     &
                        +     7.0_wp * ibit10 * adv_mom_3                     &
@@ -4050,5 +4386,5 @@
                                                  )
 
-                diss_r(k) = - ABS( u_comp(k) - gu ) * (                      &
+                diss_r = - ABS( u_comp - gu ) * (                            &
                           ( 10.0_wp * ibit11 * adv_mom_5                     &
                        +     3.0_wp * ibit10 * adv_mom_3                     & 
@@ -4065,10 +4401,52 @@
                                                      )
 
+#ifdef _OPENACC
+!
+!--             Recompute the left fluxes.
+                ibit11_l = REAL( IBITS(advc_flags_1(k,j,i-1),11,1), KIND = wp )
+                ibit10_l = REAL( IBITS(advc_flags_1(k,j,i-1),10,1), KIND = wp )
+                ibit9_l  = REAL( IBITS(advc_flags_1(k,j,i-1),9,1),  KIND = wp )
+
+                u_comp_l = u(k,j,i) + u(k,j,i-1) - gu
+                flux_l   = u_comp_l * (                                        &
+                                       ( 37.0_wp * ibit11_l * adv_mom_5           &
+                                    +     7.0_wp * ibit10_l * adv_mom_3           &
+                                    +              ibit9_l  * adv_mom_1           &
+                                       ) *                                     &
+                                     ( u(k,j,i)   + u(k,j,i-1) )               &
+                                -      (  8.0_wp * ibit11_l * adv_mom_5           &
+                                    +              ibit10_l * adv_mom_3           &
+                                       ) *                                     &
+                                     ( u(k,j,i+1) + u(k,j,i-2) )               &
+                                +      (           ibit11_l * adv_mom_5           &
+                                       ) *                                     &
+                                     ( u(k,j,i+2) + u(k,j,i-3) )               &
+                                                   )
+
+                diss_l   = - ABS( u_comp_l ) * (                               &
+                                       ( 10.0_wp * ibit11_l * adv_mom_5           &
+                                    +     3.0_wp * ibit10_l * adv_mom_3           &
+                                    +              ibit9_l  * adv_mom_1           &
+                                       ) *                                     &
+                                     ( u(k,j,i)   - u(k,j,i-1) )               &
+                                -      (  5.0_wp * ibit11_l * adv_mom_5           &
+                                    +              ibit10_l * adv_mom_3           &
+                                       ) *                                     &
+                                     ( u(k,j,i+1) - u(k,j,i-2) )               &
+                                +      (           ibit11_l * adv_mom_5           &
+                                       ) *                                     &
+                                     ( u(k,j,i+2) - u(k,j,i-3) )               &
+                                                             )
+#else
+                flux_l = swap_flux_x_local_u(k,j)
+                diss_l = swap_diss_x_local_u(k,j)
+#endif
+
                 ibit14 = REAL( IBITS(advc_flags_1(k,j,i),14,1), KIND = wp )
                 ibit13 = REAL( IBITS(advc_flags_1(k,j,i),13,1), KIND = wp )
                 ibit12 = REAL( IBITS(advc_flags_1(k,j,i),12,1), KIND = wp )
 
-                v_comp    = v(k,j+1,i) + v(k,j+1,i-1) - gv
-                flux_n(k) = v_comp * (                                       &
+                v_comp = v(k,j+1,i) + v(k,j+1,i-1) - gv
+                flux_n = v_comp * (                                          &
                           ( 37.0_wp * ibit14 * adv_mom_5                     &
                        +     7.0_wp * ibit13 * adv_mom_3                     &
@@ -4085,5 +4463,5 @@
                                                  )
 
-                diss_n(k) = - ABS ( v_comp ) * (                             &
+                diss_n = - ABS ( v_comp ) * (                                &
                           ( 10.0_wp * ibit14 * adv_mom_5                     &
                        +     3.0_wp * ibit13 * adv_mom_3                     &
@@ -4099,4 +4477,47 @@
                                  ( u(k,j+3,i) - u(k,j-2,i) )                 &
                                                       )
+
+#ifdef _OPENACC
+!
+!--             Recompute the south fluxes.
+                ibit14_s = REAL( IBITS(advc_flags_1(k,j-1,i),14,1), KIND = wp )
+                ibit13_s = REAL( IBITS(advc_flags_1(k,j-1,i),13,1), KIND = wp )
+                ibit12_s = REAL( IBITS(advc_flags_1(k,j-1,i),12,1), KIND = wp )
+
+                v_comp_s = v(k,j,i) + v(k,j,i-1) - gv
+                flux_s   = v_comp_s * (                                      &
+                                   ( 37.0_wp * ibit14_s * adv_mom_5             &
+                                +     7.0_wp * ibit13_s * adv_mom_3             &
+                                +              ibit12_s * adv_mom_1             &
+                                   ) *                                       &
+                                     ( u(k,j,i)   + u(k,j-1,i) )             &
+                            -      (  8.0_wp * ibit14_s * adv_mom_5             &
+                            +                  ibit13_s * adv_mom_3             &
+                                   ) *                                       &
+                                     ( u(k,j+1,i) + u(k,j-2,i) )             &
+                        +      (               ibit14_s * adv_mom_5             &
+                               ) *                                           &
+                                     ( u(k,j+2,i) + u(k,j-3,i) )             &
+                                               )
+
+                diss_s   = - ABS ( v_comp_s ) * (                            &
+                                   ( 10.0_wp * ibit14_s * adv_mom_5              &
+                                +     3.0_wp * ibit13_s * adv_mom_3              &
+                                +              ibit12_s * adv_mom_1              &
+                                   ) *                                        &
+                                     ( u(k,j,i)   - u(k,j-1,i) )              &
+                            -      (  5.0_wp * ibit14_s * adv_mom_5              &
+                                +              ibit13_s * adv_mom_3              &
+                                   ) *                                        &
+                                     ( u(k,j+1,i) - u(k,j-2,i) )              &
+                            +      (           ibit14_s * adv_mom_5              &
+                                   ) *                                        &
+                                     ( u(k,j+2,i) - u(k,j-3,i) )              &
+                                                         )
+#else
+                flux_s = swap_flux_y_local_u(k)
+                diss_s = swap_diss_y_local_u(k)
+#endif
+
 !
 !--             k index has to be modified near bottom and top, else array
@@ -4110,6 +4531,6 @@
                 k_mm  = k - 2 * ibit17
 
-                w_comp    = w(k,j,i) + w(k,j,i-1)
-                flux_t(k) = w_comp * rho_air_zw(k) * (                       &
+                w_comp = w(k,j,i) + w(k,j,i-1)
+                flux_t = w_comp * rho_air_zw(k) * (                          &
                           ( 37.0_wp * ibit17 * adv_mom_5                     &
                        +     7.0_wp * ibit16 * adv_mom_3                     &
@@ -4126,5 +4547,5 @@
                                       )
 
-                diss_t(k) = - ABS( w_comp ) * rho_air_zw(k) * (              &
+                diss_t = - ABS( w_comp ) * rho_air_zw(k) * (                 &
                           ( 10.0_wp * ibit17 * adv_mom_5                     &
                        +     3.0_wp * ibit16 * adv_mom_3                     &
@@ -4144,5 +4565,5 @@
 !--             correction is needed to overcome numerical instabilities caused
 !--             by a not sufficient reduction of divergences near topography.
-                div = ( ( u_comp(k) * ( ibit9 + ibit10 + ibit11 )             &
+                div = ( ( u_comp * ( ibit9 + ibit10 + ibit11 )                &
                 - ( u(k,j,i)   + u(k,j,i-1)   )                               &
                                     * (                                       &
@@ -4173,37 +4594,40 @@
 
                 tend(k,j,i) = tend(k,j,i) - (                                  &
-                 ( flux_r(k) + diss_r(k)                                       &
-               -   swap_flux_x_local_u(k,j) - swap_diss_x_local_u(k,j) ) * ddx &
-               + ( flux_n(k) + diss_n(k)                                       &
-               -   swap_flux_y_local_u(k)   - swap_diss_y_local_u(k)   ) * ddy &
-               + ( ( flux_t(k) + diss_t(k) )                                   &
-               -   ( flux_d    + diss_d    )                                   &
-                                                    ) * drho_air(k) * ddzw(k)  &
+                 ( ( flux_r + diss_r )                                         &
+               -   ( flux_l + diss_l ) ) * ddx                                 &
+               + ( ( flux_n + diss_n )                                         &
+               -   ( flux_s + diss_s ) ) * ddy                                 &
+               + ( ( flux_t + diss_t )                                         &
+               -   ( flux_d + diss_d ) ) * drho_air(k) * ddzw(k)               &
                                            ) + div * u(k,j,i)
 
-                swap_flux_x_local_u(k,j) = flux_r(k)
-                swap_diss_x_local_u(k,j) = diss_r(k)
-                swap_flux_y_local_u(k)   = flux_n(k)
-                swap_diss_y_local_u(k)   = diss_n(k)
-                flux_d                   = flux_t(k)
-                diss_d                   = diss_t(k)
+#ifndef _OPENACC
+                swap_flux_x_local_u(k,j) = flux_r
+                swap_diss_x_local_u(k,j) = diss_r
+                swap_flux_y_local_u(k)   = flux_n
+                swap_diss_y_local_u(k)   = diss_n
+#endif
+                flux_d                   = flux_t
+                diss_d                   = diss_t
 !
 !--             Statistical Evaluation of u'u'. The factor has to be applied
 !--             for right evaluation when gallilei_trans = .T. .
+                !$ACC ATOMIC
                 sums_us2_ws_l(k,tn) = sums_us2_ws_l(k,tn)                      &
-                + ( flux_r(k)                                                  &
-                    * ( u_comp(k) - 2.0_wp * hom(k,1,1,0)                   )  &
-                    / ( u_comp(k) - gu + SIGN( 1.0E-20_wp, u_comp(k) - gu ) )  &
-                  + diss_r(k)                                                  &
-                    *   ABS( u_comp(k) - 2.0_wp * hom(k,1,1,0)              )  &
-                    / ( ABS( u_comp(k) - gu ) + 1.0E-20_wp                  )  &
+                + ( flux_r                                                     &
+                    * ( u_comp - 2.0_wp * hom(k,1,1,0)                   )     &
+                    / ( u_comp - gu + SIGN( 1.0E-20_wp, u_comp - gu )    )     &
+                  + diss_r                                                     &
+                    *   ABS( u_comp - 2.0_wp * hom(k,1,1,0)              )     &
+                    / ( ABS( u_comp - gu ) + 1.0E-20_wp                  )     &
                   ) *   weight_substep(intermediate_timestep_count)
 !
 !--             Statistical Evaluation of w'u'.
+                !$ACC ATOMIC
                 sums_wsus_ws_l(k,tn) = sums_wsus_ws_l(k,tn)                    &
-                + ( flux_t(k)                                                  &
+                + ( flux_t                                                     &
                     * ( w_comp - 2.0_wp * hom(k,1,3,0)                   )     &
                     / ( w_comp + SIGN( 1.0E-20_wp, w_comp )              )     &
-                  + diss_t(k)                                                  &
+                  + diss_t                                                     &
                     *   ABS( w_comp - 2.0_wp * hom(k,1,3,0)              )     &
                     / ( ABS( w_comp ) + 1.0E-20_wp                       )     &
